<div class="container">
    <div class="row">
        <div class="col-md-3">
            <div class="input-group">
                <input type="file" id="file-select"
                    accept=".csv,application/vnd.openxmlformats-officedocument.spreadsheetml.sheet, application/vnd.ms-excel"
                    class="form-control form-control-sm form-control" [multiple]="false" (change)="onFileChange($event)"
                    [(ngModel)]="selectedFile" multiple="false" />
                <button class="btn btn-danger" *ngIf="selectedFile" (click)="removeFile()"><i class="fa fa-close"></i>
                </button>
            </div>
        </div>
        <div class="col-md-2">
            <button (click)="getDataOfLocalFile()" class="btn  btn-sm btn-primary">Set Data From Local File </button>
        </div>
        <div class="col-md-2">
            <a href="assets/excel/sample excel.xlsx" download="sample_excel.xlsx"
                class="btn  btn-sm btn-primary">Download
                Sample <i class="fa fa-download" aria-hidden="true"></i></a>
        </div>
        <div class="col-md-2" *ngIf="displayData?.length > 0">
            <button class="btn  btn-sm btn-primary" (click)="this.downloadViewOpen = !this.downloadViewOpen">{{
        this.downloadViewOpen ? 'Hide Download Option' : 'Show Download Option' }}</button>
        </div>
        <div class="col-md-3" *ngIf="this.selectedWorkSheetNamesArray?.length > 0">
            <!-- <label for="sel1" class="">select sheet</label> -->
            <div class="input-group">
                <div class="select-text input-group-prepend">
                    <span class="input-group-sm" id="inputGroupPrepend">select sheet</span>
                </div>
                <select class="form-select form-select-sm custom-select my-1 mr-sm-2" name="sel1" id="sel1"
                    aria-label="Default select example" [(ngModel)]="this.selectedWorkSheet"
                    (change)="onChangeSheetData(this.selectedWorkSheet)">
                    <option value="{{i}}" [selected]="sheets == this.selectedWorkSheet"
                        *ngFor="let sheets of this.selectedWorkSheetNamesArray;let i = index;">
                        {{sheets}}
                    </option>
                </select>
            </div>
        </div>
        <div *ngIf="this.isDataLoaded && this.convertedData.length == 0" style="align-items: center;">
            <br>
            <br>
            <h3 style="color:blue;text-align: center;">Select Any Excel To Show The Magic!! Or Download It From Sample
                File Button.</h3>
        </div>
        <div class="row" *ngIf="displayData?.length > 0 && this.downloadViewOpen">
            <br>
            <br>
            <div class="col-md-2 form-group">
                <button class="btn  btn-sm btn-info" (click)="export()">Download as EXCEL <i class="fa fa-download"
                        aria-hidden="true"></i></button>
            </div>
            <div class="col-md-2 form-group">
                <button type="button" class="btn  btn-sm btn-info" (click)="readAsCSV()">Download as CSV <i
                        class="fa fa-download" aria-hidden="true"></i></button>
            </div>
            <div class="col-md-2 form-group">
                <button type="button" class="btn  btn-sm btn-info" (click)="readAsJson()">Download as JSON <i
                        class="fa fa-download" aria-hidden="true"></i></button>
            </div>
            <div class="col-md-2 form-group">
                <button type="button" class="btn  btn-sm btn-info" (click)="readAsHTML()">Download as HTML <i
                        class="fa fa-download" aria-hidden="true"></i></button>
            </div>
            <div class="col-md-2 form-group">
                <button type="button" class="btn  btn-sm btn-info" (click)="readAsText()">Download as Text <i
                        class="fa fa-download" aria-hidden="true"></i></button>
            </div>
        </div>
        <div *ngIf="!this.isDataLoaded">
            <div class="d-flex justify-content-center">
                <h3 style="color: rgb(170, 21, 15);text-align: center;">Data Loading......</h3>
                <div class="spinner-border text-warning" role="status">
                    <span class="sr-only">Loading...</span>
                </div>
            </div>
        </div>
        <div *ngIf="this.displayData?.length > 0">
            <div class="table-responsive">
                <div class="table-wrapper">
                    <div class="table-title">
                        <div class="row">
                            <div class="col-sm-10">
                                <h2>Lite Bill List</h2>
                            </div>
                            <div class="col-sm-2 justify-content-end" *ngIf="displayData?.length > 0">
                                <div class="input-group">
                                    <button class="btn  btn-sm btn-primary" (click)="openAddMenu()" type="button"
                                        type="button">
                                        Add New Bill</button>
                                    <!-- <button type="button" class="btn btn-sm btn-info"><i class="fa fa-plus"></i> Add -->
                                    <!-- New</button> -->
                                </div>
                                <!-- <span class="help-block"> new unit is more than previouse unit. 
                  previous unit is : {{this.lastLiteBillData.Current_Unit | currency:"INR"}}
                </span> -->
                            </div>
                        </div>
                    </div>
                    <table class="table table-bordered" id="excel-table">
                        <thead class="table-dark">
                            <tr>
                                <th style="width: 3%;">No</th>
                                <th class="td-width" *ngFor="let col of colums">
                                    {{col}}
                                </th>
                                <!-- <th *ngFor="let co of col">{{co}}</th> -->
                                <!-- <th class="td-width"> Date</th>
            <th class="td-width"> Current Unit</th> -->
                                <!-- <th class="td-width"> Extra Unit</th> -->
                                <!-- <th class="td-width"> Previouse Unit</th> -->
                                <!-- <th class="td-width"> Extra Unit</th> -->
                                <!-- <th class="td-width"> Used Unit</th> -->
                                <!-- <th class="td-width">Extra Unit</th> -->
                                <!-- <th class="td-width"> Unit Point</th>
            <th class="td-width"> RS</th>
            <th>comments</th> -->
                            </tr>
                        </thead>
                        <tbody>
                            <!-- <tr *ngFor="let row of displayData;let i = index;let f= first;let l = last;">
                <td>{{i + this.minSize + 1}}</td>
                <td *ngFor="let ro of row;let is = index">
                  {{convertStringToNumber(ro)}}
                </td> -->
                            <!-- <td class="td-width">{{row.Date}}</td> -->
                            <!-- <td class="td-width">{{convertStringToNumber(row.Current_Unit)}}</td> -->
                            <!-- <td class="td-width">{{convertStringToNumber(row.Extra_Current_Unit)}}</td> -->
                            <!-- <td class="td-width">{{convertStringToNumber(row.Previouse_Unit)}}</td> -->
                            <!-- <td class="td-width">{{convertStringToNumber(row.Extra_Previouse_Unit)}}</td> -->
                            <!-- <td class="td-width">{{convertStringToNumber(row.Used_Unit)}}</td> -->
                            <!-- <td class="td-width">{{convertStringToNumber(row.Extra_Used_Unit)}}</td> -->
                            <!-- <td class="td-width">{{row.Unit_Point}}</td>
            <td class="td-width">{{convertStringToNumber(row.RS)}}</td>
            <td>{{row.comments}}</td> -->
                            <!-- </tr> -->
                            <!-- <tr *ngFor="let row of _.keys(convertedData);let i = index;let f= first;let l = last;">
                <td>{{i + 1}}</td>
                <td>
                  {{convertedData[row]}}
                </td>
              </tr> -->
                            <!-- <tr *ngFor='let key of _.keys(convertedData);let i = index'>
                 <td>
                   {{key}}: {{convertedData[key]}}
                 </td>
               </tr> -->
                            <tr *ngIf="this.isOpenAddMenu">
                                <!-- <form #liteBillForm="ngForm"> -->
                                <td>{{this.convertedData.length + 1}}</td>
                                <td>{{newLastBill.Date | filterData : 'Date'}}
                                    <!-- <input type="text" class="form-control-sm form-control" disabled name="Current_Unit"
                           [(ngModel)]="newLastBill.Date"> -->
                                    <!-- {{ item[key] | filterData : key}} -->
                                </td>
                                <td>
                                    <input type="number" min="0" class="form-control-sm form-control"
                                        (change)="updateData()" (keypress)="onlyNumericKey($event)" name="Current_Unit"
                                        placeholder="Current Unit" [(ngModel)]="newLastBill.Current_Unit">
                                    <!-- {{ item[key] | filterData : key}} -->
                                </td>
                                <td>{{newLastBill.Previouse_Unit}}
                                    <!-- <input type="number" min="0" disabled class="form-control-sm form-control" (keypress)="onlyNumericKey($event)"
                          placeholder="Previouse Unit"
                          name="Previouse_Unit" [(ngModel)]="newLastBill.Previouse_Unit"> -->
                                </td>
                                <td>
                                    <input type="number" min="0" (change)="updateData()"
                                        class="form-control-sm form-control" (keypress)="onlyNumericKey($event)"
                                        value="{{this.newLastBill?.Extra_Unit == '' ? '0' : this.newLastBill?.Extra_Unit}}"
                                        placeholder="Extra Unit" name="Extra_Unit" [(ngModel)]="newLastBill.Extra_Unit">
                                </td>
                                <td>
                                    <input type="number" min="0" class="form-control-sm form-control"
                                        (keypress)="onlyNumericKey($event)" disabled placeholder="Used Unit"
                                        name="Used_Unit" [(ngModel)]="newLastBill.Used_Unit">
                                </td>
                                <td>
                                    <input type="number" min="0" (change)="updateData()"
                                        class="form-control-sm form-control" (keypress)="onlyNumericKey($event)"
                                        placeholder="Unit Point" name="Unit_Point" [(ngModel)]="newLastBill.Unit_Point">
                                </td>
                                <td>
                                    <input type="text" value="{{newLastBill.RS}}" class="form-control-sm form-control"
                                        disabled placeholder="RS" name="RS" [(ngModel)]="newLastBill.RS">
                                </td>
                                <td>
                                    <!-- <input type="text" class="form-control-sm form-control" name="Comments" [(ngModel)]="newLastBill.Comments"> -->
                                    <div class="input-group">
                                        <input type="text" class="form-control form-control-sm form-control" min="1"
                                            name="Comments" [(ngModel)]="newLastBill.Comments" required
                                            aria-label="comments" placeholder="comments"
                                            aria-describedby="basic-addon2">
                                        <div class="input-group-append">
                                            <button class="btn  btn-sm btn-primary"
                                                [disabled]="!(this.newLastBill.RS > 0)" (click)="addNewLiteBill()"
                                                type="button" type="button">
                                                <i class="fa fa-plus" aria-hidden="true"></i> Add New
                                                Bill</button>
                                            <!-- <button type="button" class="btn btn-sm btn-info"><i class="fa fa-plus"></i> Add -->
                                            <!-- New</button> -->
                                            <br>
                                        </div>
                                    </div>
                                </td>
                                <!-- </form> -->
                            </tr>
                            <tr *ngFor='let row of displayData;let i = index'>
                                <td>{{i + this.minSize + 1}}</td>
                                <td *ngFor="let key of objectKeys(row);let is = index">
                                    {{ row[key] | filterData : key}}
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
                <div class="row">
                    <div class="col-md-4">
                        <nav>
                            <ul class="pagination pagination-design m-0">
                                <li class="page-item">
                                    <button class="page-link disabled">
                                        Page : {{this.currentPage}}/{{this.pages.length}}
                                    </button>
                                </li>
                                <li class="page-item">
                                    <button class="page-link disabled">
                                        Record : {{this.minSize + 1}} to
                                        {{ this.currentPage === this.pages.length ?  this.totalRecords : this.maxSize}}/{{this.totalRecords}}
                                    </button>
                                </li>
                            </ul>
                        </nav>
                    </div>
                    <div class="offset-4 col-md-4">
                        <nav>
                            <ul class="pagination pagination-design justify-content-start m-0">
                                <li class="page-item">
                                    <button (click)="gotoFisrtPage()" [disabled]="currentPage == 1"
                                        class="page-link {{[currentPage == 1 ? 'button-disable' : ' ']}}">
                                        <span><i class="fa  fa-angle-double-left"></i></span>
                                    </button>
                                </li>
                                <li class="page-item">
                                    <button (click)="previous()" [disabled]="currentPage == 1"
                                        class="page-link {{[currentPage == 1 ? 'button-disable' : ' ']}}">
                                        <span><i class="fa fa-arrow-circle-left"></i></span>
                                    </button>
                                </li>
                                <li class="page-item " aria-current="page" *ngFor="let p of pages; let i = index"
                                    [ngClass]="{'active': i+1 == page }">
                                    <a class="page-link" href="" (click)="setPage(i+1,$event)">{{i+1}}</a>
                                </li>
                                <li class="page-item">
                                    <button (click)="next()" [disabled]="currentPage == pages.length"
                                        class="page-link {{[currentPage == pages.length ? 'button-disable' : ' ']}}">
                                        <span><i class="fa fa-arrow-circle-right"></i></span>
                                    </button>
                                </li>
                                <li class="page-item">
                                    <button (click)="gotoLastPage()" [disabled]="currentPage == pages.length"
                                        class="page-link {{[currentPage == pages.length ? 'button-disable' : ' ']}}">
                                        <span><i class="fa fa-angle-double-right"></i></span>
                                    </button>
                                </li>
                            </ul>
                        </nav>

                    </div>
                </div>
            </div>
        </div>
        <!-- <router-outlet></router-outlet> -->
        <br>
    </div>
</div>
